var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var users_exports = {};
__export(users_exports, {
  listExcludeRole: () => listExcludeRole,
  updateProfile: () => updateProfile
});
module.exports = __toCommonJS(users_exports);
var import_actions = require("@nocobase/actions");
async function updateProfile(ctx, next) {
  const { values } = ctx.action.params;
  const { currentUser } = ctx.state;
  if (!currentUser) {
    ctx.throw(401);
  }
  const UserRepo = ctx.db.getRepository("users");
  const result = await UserRepo.update({
    filterByTk: currentUser.id,
    values
  });
  ctx.body = result;
  await next();
}
const listExcludeRole = async (ctx, next) => {
  const { roleName, page = import_actions.DEFAULT_PAGE, pageSize = import_actions.DEFAULT_PER_PAGE } = ctx.action.params;
  const repo = ctx.db.getRepository("users");
  const users = await repo.find({
    fields: ["id"],
    filter: {
      "roles.name": roleName
    }
  });
  const userIds = users.map((user) => user.id);
  if (userIds.length) {
    ctx.action.mergeParams({
      filter: {
        id: {
          $notIn: userIds
        }
      }
    });
  }
  const { filter } = ctx.action.params;
  const [rows, count] = await repo.findAndCount({
    context: ctx,
    offset: (page - 1) * pageSize,
    limit: pageSize,
    filter
  });
  ctx.body = {
    count,
    rows,
    page: Number(page),
    pageSize: Number(pageSize),
    totalPage: Math.ceil(count / pageSize)
  };
  await next();
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  listExcludeRole,
  updateProfile
});
